/*
 * JemmySampleMainFrame.java
 *
 * Created on 2011-05-01, 12:55:05
 */

package jemmysample;

import java.util.ArrayList;
import java.util.Random;
import java.util.Vector;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;

/**
 *
 * @author Pawel Prokop <prokop@adfinem.net>
 */
public class JemmySampleMainFrame extends javax.swing.JFrame {

    ArrayList<String> itemList = new ArrayList<String> ();

    /** Creates new form JemmySampleMainFrame */
    public JemmySampleMainFrame() {
        createItemList();
        initComponents();
        CommonUI.setCenterPos(this);
    }


    /**
     * Create list with album titles
     *
     * @return
     */
    private ArrayList<String> createItemList() {
        itemList.clear();
        
        itemList.add("The Piper at the Gates of Dawn");
        itemList.add("A Saucerful of Secrets");
        itemList.add("More");
        itemList.add("Ummagumma");
        itemList.add("Atom Heart Mother");
        itemList.add("Meddle");
        itemList.add("Obscured by Clouds");
        itemList.add("The Dark Side of the Moon");
        itemList.add("Wish You Were Here");
        itemList.add("Animals");
        itemList.add("The Wall");
        itemList.add("The Final Cut");
        itemList.add("A Momentary Lapse of Reason");
        itemList.add("The Division Bell");

        return itemList;
    }


    private ComboBoxModel createListModel() {

        ComboBoxModel model = new DefaultComboBoxModel(
                new Vector(itemList));
        return model;
    }

    private String getChoosenAlbum() {
        if (btnFixed.isSelected()) {
            return (String) cmbFixed.getSelectedItem();
        }
        else if (btnCustom.isSelected()) {
            return (String) txtCustom.getText();
        }
        else {
            Random random = new Random();
            int rnd = random.nextInt(itemList.size());
            return itemList.get(rnd);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        btnCustom = new javax.swing.JRadioButton();
        btnFixed = new javax.swing.JRadioButton();
        btnRandom = new javax.swing.JRadioButton();
        jPanel2 = new javax.swing.JPanel();
        lblFixed = new javax.swing.JLabel();
        cmbFixed = new javax.swing.JComboBox();
        lblCustom = new javax.swing.JLabel();
        txtCustom = new javax.swing.JTextField();
        btnShow = new javax.swing.JButton();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Jemmy Sample");
        setResizable(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Selection", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 24))); // NOI18N

        buttonGroup1.add(btnCustom);
        btnCustom.setFont(new java.awt.Font("Dialog", 1, 24)); // NOI18N
        btnCustom.setText("custom");
        btnCustom.setName("btnCustom"); // NOI18N
        btnCustom.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                btnCustomStateChanged(evt);
            }
        });

        buttonGroup1.add(btnFixed);
        btnFixed.setFont(new java.awt.Font("Dialog", 1, 24)); // NOI18N
        btnFixed.setSelected(true);
        btnFixed.setText("fixed");
        btnFixed.setName("btnFixed"); // NOI18N
        btnFixed.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                btnFixedStateChanged(evt);
            }
        });

        buttonGroup1.add(btnRandom);
        btnRandom.setFont(new java.awt.Font("Dialog", 1, 24)); // NOI18N
        btnRandom.setText("random");
        btnRandom.setName("btnRandom"); // NOI18N
        btnRandom.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                btnRandomStateChanged(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnRandom, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(btnCustom, javax.swing.GroupLayout.DEFAULT_SIZE, 120, Short.MAX_VALUE)
                    .addComponent(btnFixed, javax.swing.GroupLayout.DEFAULT_SIZE, 120, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(btnFixed)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnCustom)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnRandom)
                .addGap(20, 20, 20))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        lblFixed.setFont(new java.awt.Font("Dialog", 1, 24)); // NOI18N
        lblFixed.setText("fixed:");
        lblFixed.setName("lblFixed"); // NOI18N

        cmbFixed.setFont(new java.awt.Font("Arial", 0, 18)); // NOI18N
        cmbFixed.setModel(createListModel());
        cmbFixed.setName("cmbFixed"); // NOI18N

        lblCustom.setFont(new java.awt.Font("Dialog", 1, 24)); // NOI18N
        lblCustom.setText("custom:");
        lblCustom.setEnabled(false);
        lblCustom.setName("lblCustom"); // NOI18N

        txtCustom.setFont(new java.awt.Font("Arial", 0, 18)); // NOI18N
        txtCustom.setEnabled(false);
        txtCustom.setName("txtCustom"); // NOI18N

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblCustom)
                    .addComponent(lblFixed))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(cmbFixed, 0, 341, Short.MAX_VALUE)
                    .addComponent(txtCustom, javax.swing.GroupLayout.DEFAULT_SIZE, 341, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblFixed)
                    .addComponent(cmbFixed, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblCustom)
                    .addComponent(txtCustom, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(91, Short.MAX_VALUE))
        );

        btnShow.setFont(new java.awt.Font("Dialog", 1, 24)); // NOI18N
        btnShow.setText("Play");
        btnShow.setName("btnPlay"); // NOI18N
        btnShow.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnShowActionPerformed(evt);
            }
        });

        jMenu1.setText("File");

        jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.ALT_MASK));
        jMenuItem1.setText("Exit");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuBar1.add(jMenu1);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(294, 294, 294)
                        .addComponent(btnShow)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnShow)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnShowActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnShowActionPerformed
        AlbumsDlg dlg = new AlbumsDlg(this, true);
        dlg.setAlbum(getChoosenAlbum());
        dlg.setVisible(true);
    }//GEN-LAST:event_btnShowActionPerformed

    private void btnFixedStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_btnFixedStateChanged
        boolean enabled = btnFixed.isSelected();
        cmbFixed.setEnabled(enabled);
        lblFixed.setEnabled(enabled);
    
    }//GEN-LAST:event_btnFixedStateChanged

    private void btnCustomStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_btnCustomStateChanged
        boolean enabled = btnCustom.isSelected();
        txtCustom.setEnabled(enabled);
        lblCustom.setEnabled(enabled);
        
    }//GEN-LAST:event_btnCustomStateChanged

    private void btnRandomStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_btnRandomStateChanged
        
    }//GEN-LAST:event_btnRandomStateChanged

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        dispose();
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new JemmySampleMainFrame().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton btnCustom;
    private javax.swing.JRadioButton btnFixed;
    private javax.swing.JRadioButton btnRandom;
    private javax.swing.JButton btnShow;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JComboBox cmbFixed;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JLabel lblCustom;
    private javax.swing.JLabel lblFixed;
    private javax.swing.JTextField txtCustom;
    // End of variables declaration//GEN-END:variables

}
